#ifndef _TROOPER_H_
#define _TROOPER_H_

class Trooper
{
public:
    enum trooper_state
    {
	DEAD = 0,
	JUMP,
	FALL,
	FLOAT,
	STAND,
	WALK,
    };

    // constructor / destructor
    Trooper();

    // draw functions
    void draw();
    void draw_man();
    void draw_canopy();
    
    // update function
    void update();

    // collision detection
    int intersect_canopy(float *l1, float *l2, int n);
    
    float pos[3];
    float v[3];
    int state;
    float angle;
    float shoulders;          // shoulder height
    float open_height;        // how brave are we
    
    // linked list storage
    Trooper *next;
};

#endif
